%    <CustomTools>
%      <Menu>
%        <Item name="Add Image to Scene" icon="Matlab">
%          <Command>MatlabXT::AddImage2SceneXT(%i)</Command>
%        </Item>
%      </Menu>
%    </CustomTools>









function [] = AddImage2SceneXT(aImarisApplicationID)
%UNTITLED3 Summary of this function goes here
%   Detailed explanation goes here
   
% ProgressDisplay = waitbar(0, 'Getting Image,please wait...');
if ~isnumeric(aImarisApplicationID)
    aImarisApplicationID=str2num(aImarisApplicationID);
end

if ~isnumeric(aImarisApplicationID) && ~ischar(aImarisApplicationID)
    aImarisApplicationID=0;
end
global vImarisApplication;

if ~isa(aImarisApplicationID, 'Imaris.IApplicationPrxHelper')
  javaaddpath ImarisLib.jar
  vImarisLib = ImarisLib;
  if ischar(aImarisApplicationID)
    aImarisApplicationID = round(str2double(aImarisApplicationID));
  end
   vImarisApplication = vImarisLib.GetApplication(aImarisApplicationID);
else
  vImarisApplication = aImarisApplicationID;
end

vDataSet1 = vImarisApplication.GetDataSet.Clone;

vSurpassScene = vImarisApplication.GetSurpassScene;
aType = Imaris.tType.eTypeFloat;

if strcmp(vDataSet1.GetType,'eTypeUInt8')
    vImarisApplication.GetDataSet.SetType(aType);
elseif strcmp(vDataSet1.GetType,'eTypeUInt16')
    vImarisApplication.GetDataSet.SetType(aType);
end    





%Get DataSet Info for voxel sizing etc...
vDataMin1 = [vDataSet1.GetExtendMinX, vDataSet1.GetExtendMinY, vDataSet1.GetExtendMinZ];
vDataMax1 = [vDataSet1.GetExtendMaxX, vDataSet1.GetExtendMaxY, vDataSet1.GetExtendMaxZ];
vDataSize1 = [vDataSet1.GetSizeX, vDataSet1.GetSizeY, vDataSet1.GetSizeZ];

vTimeMax1 = vDataSet1.GetSizeT - 1;

SizeX1 = vDataSet1.GetSizeX;
SizeY1 = vDataSet1.GetSizeY;
SizeZ1 = vDataSet1.GetSizeZ;
PixelSize1 = (vDataSet1.GetExtendMaxX)/SizeX1;
PixelDepth1 = (vDataSet1.GetExtendMaxZ)/SizeZ1;
vNumberOfChannels1 = vDataSet1.GetSizeC;

for vTime=1:vTimeMax1+1 
    for channel=1:vNumberOfChannels1
        [Image1{vTime,channel},thisVoxelSize] = XTGetImarisImageMWA(vImarisApplication,vTime,channel);
    end    
end    

[FileName,PathName,FilterIndex]=uigetfile('*.ims','Select Image to Add to Scene');


vImarisApplication.FileOpen([PathName FileName],'');



vDataSet2 = vImarisApplication.GetDataSet.Clone;


vDataMin2 = [vDataSet2.GetExtendMinX, vDataSet2.GetExtendMinY, vDataSet2.GetExtendMinZ];
vDataMax2 = [vDataSet2.GetExtendMaxX, vDataSet2.GetExtendMaxY, vDataSet2.GetExtendMaxZ];
vDataSize2 = [vDataSet2.GetSizeX, vDataSet2.GetSizeY, vDataSet2.GetSizeZ];

vTimeMax2 = vDataSet2.GetSizeT - 1;

SizeX2 = vDataSet2.GetSizeX;
SizeY2 = vDataSet2.GetSizeY;
SizeZ2 = vDataSet2.GetSizeZ;
PixelSize2 = (vDataSet2.GetExtendMaxX)/SizeX2;
PixelDepth2 = (vDataSet2.GetExtendMaxZ)/SizeZ2;
vNumberOfChannels2 = vDataSet2.GetSizeC;
Xmatch=isequal(SizeX1,SizeX2);
Ymatch=isequal(SizeY1,SizeY2);
Zmatch=isequal(SizeZ1,SizeZ2);
RESmatch=isequal(PixelSize1,PixelSize2) && isequal(PixelDepth1,PixelDepth2);

%%get color from channels of image with most channels
if vNumberOfChannels1>vNumberOfChannels2
    for i=1 : vNumberOfChannels1
        color{i}=vDataSet1.GetChannelColorRGBA(i-1);
    end
end

if vNumberOfChannels2>vNumberOfChannels1
    for i=1 : vNumberOfChannels2
        color{i}=vDataSet2.GetChannelColorRGBA(i-1);
    end
end

if vNumberOfChannels1==vNumberOfChannels2
    for i=1 : vNumberOfChannels1
        color{i}=vDataSet1.GetChannelColorRGBA(i-1);
    end
end

if Zmatch && RESmatch   
    for timePoint=1:vTimeMax1+1
        for channel=1:vNumberOfChannels1
            for i=1:SizeZ1
                Image1{timePoint,channel}(SizeX1+1:SizeX1+10,:,i)=0;
            end    
        end
    end
    SizeX1=SizeX1+10;
end

if ~isequal(PixelSize1,PixelSize2) || ~isequal(PixelDepth1,PixelDepth2)
    warndlg(['resolutions do not match!'...
         '  proceeding may result in rounding errors for scaling of Images.']);
    urChoice=menu('matching resolutions may create a very large image! Are you sure you want to proceed','YES','NO');
    if urChoice==2
        error('user canceled extension.');
    end
end    

progressDisplay=waitbar(0,'getting second Image');
for vTime=1:vTimeMax2+1 
    for channel=1:vNumberOfChannels2
        [Image2{vTime,channel},thisVoxelSize] = XTGetImarisImageMWA(vImarisApplication,vTime,channel);
    end    
    waitbar(vTime/(vTimeMax2+1),progressDisplay);
end    

%%ResMatch
if PixelSize1>PixelSize2
    ResRatioX=PixelSize1/PixelSize2;
    for vTime=1:vTimeMax1+1
        waitbar(vTime/(vTimeMax1+1),progressDisplay,'resolving XY resolution difference');
        for channel=1:vNumberOfChannels1
            for zSlice=1:SizeZ1
                thisStack(:,:,zSlice)=imageresize(Image1{vTime,channel}(:,:,zSlice),ResRatioX,ResRatioX);
            end
            Image1{vTime,channel}=thisStack;
        end
    end    
    newXYResImage=2;
    PixelSize1=PixelSize2;
    [SizeX1,SizeY1,SizeZ1]=size(Image1{1,1});
end

if PixelSize2>PixelSize1
    ResRatioX=PixelSize2/PixelSize1;
    for vTime=1:vTimeMax2+1
        waitbar(vTime/(vTimeMax2+1),progressDisplay,'resolving XY resolution difference');
        for channel=1:vNumberOfChannels2
            for zSlice=1:SizeZ2
                thisStack(:,:,zSlice)=imageresize(Image2{vTime,channel}(:,:,zSlice),ResRatioX,ResRatioX);
            end
            Image2{vTime,channel}=thisStack;
        end
    end    
    newXYResImage=1;
    PixelSize2=PixelSize1;
    [SizeX2,SizeY2,SizeZ2]=size(Image2{1,1});
end
 
if PixelDepth1>PixelDepth2
    ResRatioZ=(PixelDepth1/PixelDepth2);
    for vTime=1:vTimeMax1+1
        waitbar(vTime/(vTimeMax1+1),progressDisplay,'please wait:  resolving Z resolution difference');
        for channel=1:vNumberOfChannels1
            if SizeZ1>1
                for xSlice=1:SizeX1
                    thisWierdSlice(:,:)=Image1{vTime,channel}(xSlice,:,:);
                    thisSlice{xSlice}=imageresize(thisWierdSlice,1, ResRatioZ);
                end    
            else
                for xSlice=1:SizeX1
                    thisWierdSlice(:,:)=Image1{vTime,channel}(xSlice,:);
                    thisSlice{xSlice}=imageresize(thisWierdSlice,1,ResRatioZ);
                end    
            end    
            Image1{vTime,channel}=[];
            for backin=1:SizeX1
                Image1{vTime,channel}(backin,:,:)=thisSlice{backin};
            end    
        end
    end 
    newZresImage=2;
    PixelDepth1=PixelDepth2;
    [SizeX1,SizeY1,SizeZ1]=size(Image1{1,1});
end

if PixelDepth2>PixelDepth1
    ResRatioZ=(PixelDepth2/PixelDepth1);
    for vTime=1:vTimeMax2+1
        waitbar(vTime/(vTimeMax2+1),progressDisplay,'please wait:  resolving Z resolution difference');
        for channel=1:vNumberOfChannels2
            
            if SizeZ2>1
                for xSlice=1:SizeX2
                    thisWierdSlice(:,:)=Image2{vTime,channel}(xSlice,:,:);
                    thisSlice{xSlice}=imageresize(thisWierdSlice,1,ResRatioZ);
                end    
            else
                for xSlice=1:SizeX2
                    thisWierdSlice(:,:)=Image2{vTime,channel}(xSlice,:);
                    thisSlice{xSlice}=imageresize(thisWierdSlice,1,ResRatioZ);
                end    
            end    
            Image2{vTime,channel}=[];
            for backin=1:SizeX2
                Image2{vTime,channel}(backin,:,:)=thisSlice{backin};
            end    
        end
    end 
    newZresImage=1;
    PixelDepth2=PixelDepth1;
    [SizeX2,SizeY2,SizeZ2]=size(Image2{1,1});
end

%%Xmatch
% if SizeX2>SizeX1
%     AddColumns=SizeX2-SizeX1;
for timePoint=1:vTimeMax1+1
    waitbar(timePoint/(vTimeMax1+1),progressDisplay,'Buffering X-dim of Image 1');
    for channel=1:vNumberOfChannels1
        for i=1:SizeZ1
            Image1{timePoint,channel}(SizeX1+1:SizeX1+20,:,i)=0;
        end    
    end
end
SizeX1=SizeX1+20;
% end    

% if SizeX1>SizeX2
%     AddColumns=SizeX1-SizeX2;
%     for timePoint=1:vTimeMax2+1
%         waitbar(timePoint/(vTimeMax2+1),progressDisplay,'Buffering X-dim of Image 2');
%         for channel=1:vNumberOfChannels2
%             for i=1:SizeZ2
%                 Image2{timePoint,channel}(SizeX2+1:SizeX1,:,i)=0;
%             end    
%         end
%     end
%     SizeX2=SizeX1;
% end    

%%Ymatch
if SizeY2>SizeY1
    AddRows=SizeY2-SizeY1;
    for timePoint=1:vTimeMax1+1
        waitbar(timePoint/(vTimeMax1+1),progressDisplay,'Buffering Y-dim of Image 1');
        for channel=1:vNumberOfChannels1
            for i=1:SizeZ1
                Image1{timePoint,channel}(:,SizeY1+1:SizeY2,i)=0;
            end    
        end
    end
    SizeY1=SizeY2;
end    

if SizeY1>SizeY2
    AddRows=SizeY1-SizeY2;
    for timePoint=1:vTimeMax2+1
        waitbar(timePoint/(vTimeMax2+1),progressDisplay,'Buffering Y-dim of Image 2');
        for channel=1:vNumberOfChannels2
            for i=1:SizeZ2
                Image2{timePoint,channel}(:,SizeY2+1:SizeY1,i)=0;
            end    
        end
    end
    SizeY2=SizeY1;
end    

%%ZMatch
if SizeZ2>SizeZ1
    AddSlices=SizeZ2-SizeZ1;
    for timePoint=1:vTimeMax1+1
        waitbar(timePoint/(vTimeMax1+1),progressDisplay,'Buffering Z-dim of Image 1');
        for channel=1:vNumberOfChannels1
            for i=1:AddSlices
                Image1{timePoint,channel}(:,:,SizeZ1+i)=zeros(size(Image1{timePoint,channel}(:,:,1)));
            end    
        end
    end
    SizeZ1=SizeZ2;
end    


if SizeZ1>SizeZ2
    AddSlices=SizeZ1-SizeZ2;
    for timePoint=1:vTimeMax2+1
        waitbar(timePoint/(vTimeMax2+1),progressDisplay,'Buffering Z-dim of Image 2');
        for channel=1:vNumberOfChannels2
            for i=1:AddSlices
                Image2{timePoint,channel}(:,:,SizeZ2+i)=zeros(size(Image2{timePoint,channel}(:,:,1)));
            end    
        end
    end
    SizeZ2=SizeZ1;
end    


%%time match

if vTimeMax2>vTimeMax1
    for timePoint=(vTimeMax1+2):(vTimeMax2+1)
        waitbar(timePoint/(vTimeMax2+1),progressDisplay,'Buffering T-dim of Image 1');
        for channel=1:vNumberOfChannels1
            Image1{timePoint,channel}=zeros(size(Image1{vTimeMax1+1,channel}));
        end
    end
    vTimeMax1=vTimeMax2;
end


if vTimeMax1>vTimeMax2
    for timePoint=(vTimeMax2+2):(vTimeMax1+1)
        waitbar(timePoint/(vTimeMax1+1),progressDisplay,'Buffering T-dim of Image 2');
        for channel=1:vNumberOfChannels2
            Image2{timePoint,channel}=zeros(size(Image2{vTimeMax2+1,channel}));
        end
    end
    vTimeMax2=vTimeMax1;
end


%%channel Match
if vNumberOfChannels2>vNumberOfChannels1
    for timePoint=1:(vTimeMax1+1)
        waitbar(timePoint/(vTimeMax1+1),progressDisplay,'Buffering Channels of Image 1');
        for channel=vNumberOfChannels1+1:vNumberOfChannels2
            Image1{timePoint,channel}=zeros(size(Image1{timePoint,channel-1}));
        end
    end
    vNumberOfChannels1=vNumberOfChannels2;
end

if vNumberOfChannels1>vNumberOfChannels2
    for timePoint=1:(vTimeMax2+1)
        waitbar(timePoint/(vTimeMax2+1),progressDisplay,'Buffering Channels of Image 2');
        for channel=vNumberOfChannels2+1:vNumberOfChannels1
            Image2{timePoint,channel}=zeros(size(Image2{timePoint,channel-1}));
        end
    end
    vNumberOfChannels2=vNumberOfChannels1;
end    





waitbar(1,progressDisplay,'please be patient..this is slow..Setting new Dimensions(progress bar will not update!)');
[nTime,nChannels]=size(Image1);

vDataSet2.SetSizeX((SizeX1+SizeX2));

vDataSet2.SetSizeY(SizeY1);

vDataSet2.SetSizeZ(SizeZ1);

vDataSet2.SetSizeT(nTime);

vDataSet2.SetSizeC(nChannels);

vDataSet2.SetExtendMinX(0);
vDataSet2.SetExtendMaxX((SizeX1+SizeX2)*PixelSize1);

vDataSet2.SetExtendMinY(0);
vDataSet2.SetExtendMaxY(SizeY1*PixelSize1);

vDataSet2.SetExtendMinZ(0);
vDataSet2.SetExtendMaxZ(PixelDepth1*SizeZ1);

for i=1:nChannels
    vDataSet2.SetChannelColorRGBA(i-1,color{i});
end    

for vTime=1:nTime
    waitbar(vTime/(nTime),progressDisplay,'Building and Setting New Combined Image');
    for channel=1:nChannels
        TotalImage=cat(1,Image1{vTime,channel},Image2{vTime,channel});
        XTSetImarisImageMWA(vImarisApplication, vDataSet2, TotalImage, vTime, channel);
    end
end    
vImarisApplication.SetDataSet(vDataSet2);
close(progressDisplay);






stopHere2DeBug=3;
end






function XTSetImarisImageMWA(aImarisApplication, vDataSet, aImage, aTimeIndex, aChannelIndex)


if vDataSet.GetSizeX ~= size(aImage,1)  || vDataSet.GetSizeY ~= size(aImage,2) || vDataSet.GetSizeZ ~= size(aImage,3)
   vDataSet.Resize(0,size(aImage,1), 0,size(aImage,2), 0, size(aImage,3), 0, vDataSet.GetSizeC, 0, vDataSet.GetSizeT);
end
if size(aImage,1) == vDataSet.GetSizeX && ...
        size(aImage,2) == vDataSet.GetSizeY && ...
        size(aImage,3) == vDataSet.GetSizeZ
   if strcmp(vDataSet.GetType,'eTypeUInt8')
        vMin = min(reshape(aImage,[1,numel(aImage)]));
        if vMin < 0
            aImage = aImage + vMin;
        end
        vMax = max(reshape(aImage,[1,numel(aImage)]));
        if vMax > (2^8-1)
            aImage = aImage*(2^8-1)/vMax;
        end
        vDataSet.SetDataVolumeBytes(uint8(aImage), aChannelIndex-1, aTimeIndex-1);
   elseif strcmp(vDataSet.GetType,'eTypeUInt16')
        vMin = min(reshape(aImage,[1,numel(aImage)]));
        if vMin < 0
            aImage = aImage + vMin;
        end
        vMax = max(reshape(aImage,[1,numel(aImage)]));
        if vMax > (2^16-1)
            aImage = aImage*(2^16-1)/vMax;
        end 
        vDataSet.SetDataVolumeShorts(uint16(aImage), aChannelIndex-1, aTimeIndex-1);
   elseif strcmp(vDataSet.GetType,'eTypeFloat')
        vDataSet.SetDataVolumeFloats(single(aImage), aChannelIndex-1, aTimeIndex-1);
   end
end
% aImarisApplication.SetDataSet(vDataSet);
end










function [aImage, aVoxelSize] = XTGetImarisImageMWA(aImarisApplication, aTimeIndex, aChannelIndex)

vImarisDataSet = aImarisApplication.GetDataSet;

vExtendMin = [vImarisDataSet.GetExtendMinX, vImarisDataSet.GetExtendMinY, ...
  vImarisDataSet.GetExtendMinZ];
vExtendMax = [vImarisDataSet.GetExtendMaxX, vImarisDataSet.GetExtendMaxY, ...
  vImarisDataSet.GetExtendMaxZ];
vDataSize = [vImarisDataSet.GetSizeX, vImarisDataSet.GetSizeY, ...
  vImarisDataSet.GetSizeZ, vImarisDataSet.GetSizeC, vImarisDataSet.GetSizeT];

aVoxelSize = (vExtendMax - vExtendMin) ./ vDataSize(1:3);

vMinT = 0;
vMinC = 0;

if nargin == 3 && aChannelIndex<=vDataSize(4) && aTimeIndex<=vDataSize(5)

  vMinT = aTimeIndex-1;
  vDataSize(5) = 1;
  vMinC = aChannelIndex-1;
  vDataSize(4) = 1;
  
elseif nargin == 2 && aTimeIndex<=vDataSize(5)

  vMinT = aTimeIndex-1;
  vDataSize(5) = 1;

end

vSize = [1, prod(vDataSize(1:3)), vDataSize(4:5)];

if strcmp(vImarisDataSet.GetType,'eTypeUInt8')
  aImage = zeros(vSize, 'uint8');
elseif strcmp(vImarisDataSet.GetType,'eTypeUInt16')
  aImage = zeros(vSize, 'uint16');
else
  aImage = zeros(vSize, 'single');
end

for vTimeIndex = 1:vDataSize(5)
  for vChannelIndex = 1:vDataSize(4)
    if strcmp(vImarisDataSet.GetType,'eTypeUInt8')
      aImage(1, :, vChannelIndex, vTimeIndex) = typecast(...
        vImarisDataSet.GetDataVolumeAs1DArrayBytes( ...
        vMinC + vChannelIndex-1, vMinT + vTimeIndex-1), 'uint8');
    elseif strcmp(vImarisDataSet.GetType,'eTypeUInt16')
      aImage(1, :, vChannelIndex, vTimeIndex) = typecast(...
        vImarisDataSet.GetDataVolumeAs1DArrayShorts( ...
        vMinC + vChannelIndex-1, vMinT + vTimeIndex-1), 'uint16');
    else
      aImage(1, :, vChannelIndex, vTimeIndex) = ...
        vImarisDataSet.GetDataVolumeAs1DArrayFloats( ...
        vMinC + vChannelIndex-1, vMinT + vTimeIndex-1);
    end
  end
end
aImage = reshape(aImage, vDataSize);
end

function newImage=imageresize(A, rowScale, colScale);

[row col]=size(A);

for i=1:floor(row*rowScale)
    for j=1:floor(col*colScale)
        newImage(i,j)=A(ceil(1/rowScale*i), ceil(1/colScale*j));
    end
end


end